package wpi.associations.arminerSequence;

import java.util.*;
import java.io.*;
import weka.core.*;

/*
  Maintainance log started on April 30th, 2002
    by: Keith A. Pray (kap@wpi.edu)

  February 24, 2003  - made consistent the convention of using a lower case
		       letter to start a method name. -kap
		     - added simple comments
                     - cleaned up formatting -kap
*/

public class Converter
{

//********************************************************//
// ----- Methods-----
//********************************************************//

  public static void writeInstancesToDatabase ( String databaseFileName, 
						Instances dataset )
  {
    try
    {
      String ATTRIBUTE_VALUE_CONNECTOR = "=";
      
      DBWriter dbw = new DBWriter ( databaseFileName );
      Enumeration attributes = dataset.enumerateAttributes();
      Enumeration values;
      Vector attributeNames = new Vector();
      Vector attributeIndices = new Vector();
      Attribute a;
      String s;
      int i;
      
      dbw.setDescription ( dataset.relationName() );
      
      while ( attributes.hasMoreElements() )
      {
	a = (Attribute)attributes.nextElement();
	
	values = a.enumerateValues();
	
	while ( values.hasMoreElements() )
	{
	  s = a.name() + ATTRIBUTE_VALUE_CONNECTOR + 
	    (String)values.nextElement();
	  
	  attributeNames.addElement ( s );

	  attributeIndices.addElement 
	    ( new Long ( (long)attributeNames.size() ) );

	} // end while more values

      } // end while more attributes
      
      for ( i = 0; i < attributeNames.size(); i++ )
      {
	System.out.println ( attributeNames.elementAt ( i ) );

      } // end for attribute names
      
      dbw.setColumnNames ( attributeNames );
      dbw.setAttributeIndexes ( attributeIndices );
      
      Enumeration instances = dataset.enumerateInstances();
      
      ARMinerItemset is;
      Instance ins;
      int index;
      
      while ( instances.hasMoreElements() )
      {
	is = new ARMinerItemset();
	ins = (Instance)instances.nextElement();
	
	for ( i = 0; i < dataset.numAttributes(); i++ )
	{
	  s = ins.attribute ( i ).name() + ATTRIBUTE_VALUE_CONNECTOR + 
	    ins.value ( i );

	  index = attributeNames.indexOf ( s );
	  
	  if ( index != -1 )
	  {
	    is.addItem ( index + 1 );

	  } // end if index not -1

	} // end for each attribute
	
	dbw.addRow ( is );

      } // end while more instances
      
      dbw.close();

    } // end try 

    catch ( Exception e )
    {
      System.out.println ( "Failure." );
    } // end catch exception

  } // END public static void writeInstancesToDatabase ( 
  //                                            String databaseFileName, 
  //						Instances dataset )

//********************************************************//

} // END public class Converter
